diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 2f31f7fa6..74be6157c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
@@ -18,18 +19,20 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
-        boolean renderTop = shouldSideBeRendered(renderBlocks.blockAccess, x, y + 1, z, 1);
-        boolean flag1 = shouldSideBeRendered(renderBlocks.blockAccess, x, y - 1, z, 0);
+
+        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+
+        boolean renderTop = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y + 1, z, 1);
+        boolean flag1 = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y - 1, z, 0);
         boolean[] aflag = new boolean[4];
-        aflag[0] = shouldSideBeRendered(renderBlocks.blockAccess, x, y, z - 1, 2);
-        aflag[1] = shouldSideBeRendered(renderBlocks.blockAccess, x, y, z + 1, 3);
-        aflag[2] = shouldSideBeRendered(renderBlocks.blockAccess, x - 1, y, z, 4);
-        aflag[3] = shouldSideBeRendered(renderBlocks.blockAccess, x + 1, y, z, 5);
+        aflag[0] = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z - 1, 2);
+        aflag[1] = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z + 1, 3);
+        aflag[2] = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x - 1, y, z, 4);
+        aflag[3] = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x + 1, y, z, 5);
         if(!renderTop && !flag1 && !aflag[0] && !aflag[1] && !aflag[2] && !aflag[3])
         {
             return false;
@@ -40,9 +43,7 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
         final float sideTop = 1.0f;
         final float sideNorthSouth = 0.8f;
         final float sideEastWest = 0.6f;
-        
-        double d = 0.0D;
-        double d1 = 1.0D;
+
         final float yOff = 0.001f;
         Material material = block.blockMaterial;
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
@@ -105,7 +106,7 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
             }
             tessellator.setColorOpaque_F(sideBottom * brightness * r, sideBottom * brightness * g, sideBottom * brightness * b);
 
-            renderBlocks.renderBottomFace(tessellator, block,x, y + yOff, z, getBlockTextureFromSideAndMetadata(Side.TOP, 0));
+            renderBlocks.renderBottomFace(tessellator, bounds,x, y + yOff, z, getBlockTextureFromSideAndMetadata(Side.TOP, 0));
             didRender = true;
         }
         for(int side = 0; side < 4; side++)
@@ -205,9 +206,6 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
             tessellator.addVertexWithUV(f20, y, f21, d5, d8);
             tessellator.addVertexWithUV(f17, y, f19, d4, d8);
         }
-
-        block.minY = d;
-        block.maxY = d1;
         return didRender;
     }
 
@@ -217,7 +215,7 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         Material material = blockAccess.getBlockMaterial(x, y, z);
         if(material == block.blockMaterial)
@@ -234,7 +232,7 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
         }
         else
         {
-            return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+            return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index a1190075e..50be90892 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -15,7 +15,6 @@ public class BlockModelFullyRotatable<T extends BlockFullyRotatable> extends Blo
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         final Direction dir = BlockFullyRotatable.metaToDirection(meta);
 
@@ -53,7 +52,7 @@ public class BlockModelFullyRotatable<T extends BlockFullyRotatable> extends Blo
                 renderBlocks.uvRotateBottom = 2;
                 break;
         }
-        final boolean result = renderStandardBlock(tessellator, block, x, y, z);
+        final boolean result = renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
         resetRenderBlocks();
 
         return result;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
similarity index 75%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
index 05fac8f56..efb4fe85d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
@@ -29,10 +30,11 @@ public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        boolean didRender = renderStandardBlock(tessellator, block, x, y, z);
+        AABB bounds = block.getBounds();
+        boolean didRender = renderStandardBlock(tessellator, bounds, x, y, z);
         if (RenderBlocks.fancyGrass){
             useOverlay = true;
-            didRender |= renderStandardBlock(tessellator, block, x, y, z);
+            didRender |= renderStandardBlock(tessellator, bounds, x, y, z);
             useOverlay = false;
         }
         return didRender;
@@ -41,27 +43,32 @@ public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
     public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glColor4f(brightness, brightness, brightness, alpha);
         float yOffset = 0.5F;
-        setBlockBoundsForItemRender();
+
+        AABB bounds = getBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
         tessellator.draw();
+
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
         tessellator.draw();
+
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
         tessellator.draw();
+
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
         tessellator.draw();
+
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
         tessellator.draw();
         if(renderBlocks.useInventoryTint)
         {
@@ -73,25 +80,25 @@ public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
         }
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
         tessellator.draw();
         if (RenderBlocks.fancyGrass){
             useOverlay = true;
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
-            renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+            renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
             tessellator.draw();
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
-            renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+            renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
             tessellator.draw();
             tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
-            renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+            renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
             tessellator.draw();
             tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
-            renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+            renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
             tessellator.draw();
             useOverlay = false;
         }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
similarity index 69%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
index 1dd6af6ef..4f39d4fc9 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelIce<T extends Block> extends BlockModelTransparent<T> {
@@ -9,8 +10,8 @@ public class BlockModelIce<T extends Block> extends BlockModelTransparent<T> {
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
-        return super.shouldSideBeRendered(blockAccess, x, y, z, 1 - side);
+        return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, 1 - side);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
similarity index 99%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
index 405e68ed7..ad05a9539 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
@@ -16,7 +16,6 @@ public class BlockModelJar<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         // todo: yes, i know this is horrible.
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
similarity index 97%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
index 34cdf4f63..677785f41 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
@@ -13,7 +13,6 @@ public class BlockModelLadder<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int k1 = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         IconCoordinate l = getBlockTextureFromSideAndMetadata(Side.BOTTOM, k1);
         if(renderBlocks.overrideBlockTexture != null)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
similarity index 99%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
index 96e85f80b..f3cc255b0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
@@ -14,7 +14,6 @@ public class BlockModelLantern<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         boolean isHanging = (meta & BlockLanternFirefly.MASK_HANGING) == 0;
         boolean isAngled = (meta & BlockLanternFirefly.MASK_ANGLED) != 0;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
similarity index 85%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
index f6719d342..c19c8b090 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
@@ -18,11 +19,11 @@ public class BlockModelLayer<T extends Block> extends BlockModelStandard<T> {
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side, int meta)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side, int meta)
     {
         if(side > 1 && blockAccess.getBlockId(x, y, z) == block.id && blockAccess.getBlockMetadata(x, y, z) == meta){
             return false;
         }
-        return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+        return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
similarity index 88%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index f6b4fbbc3..cdbedc79d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelLeaves<T extends Block> extends BlockModelStandard<T> {
@@ -26,7 +27,7 @@ public class BlockModelLeaves<T extends Block> extends BlockModelStandard<T> {
         return fancyGraphics ? fancyLeavesTexture : atlasIndices[side.getId()];
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         int i1 = blockAccess.getBlockId(x, y, z);
         if(!fancyGraphics && i1 == block.id)
@@ -34,7 +35,7 @@ public class BlockModelLeaves<T extends Block> extends BlockModelStandard<T> {
             return false;
         } else
         {
-            return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+            return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
similarity index 79%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
index b247f54cd..632036c09 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
@@ -6,6 +6,8 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLeavesCacao;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -24,17 +26,19 @@ public class BlockModelLeavesCacao<T extends Block> extends BlockModelLeaves<T>
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         super.render(tessellator, x, y, z);
 
+        AABB bounds = block.getBounds();
+
         final int growthRate = BlockLeavesCacao.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
             int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
-            if(Block.lightEmission[block.id] > 0) {
+            if(Blocks.lightEmission[block.id] > 0) {
                 lmc = LightmapHelper.setBlocklightValue(lmc, 15);
             }
             tessellator.setLightmapCoord(lmc);
         }else {
             brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-            if(Block.lightEmission[block.id] > 0) {
+            if(Blocks.lightEmission[block.id] > 0) {
                 brightness = 1.0f;
             }
         }
@@ -44,11 +48,11 @@ public class BlockModelLeavesCacao<T extends Block> extends BlockModelLeaves<T>
         if (growthRate > 0) {
             renderBlocks.overrideBlockTexture = growthStages[Math.min(growthRate - 1, BlockLeavesCacao.MAX_GROWTH_STATE - 1)];
             tessellator.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
-            renderNorthFace(tessellator, block, x, y, z, renderBlocks.overrideBlockTexture);
-            renderSouthFace(tessellator, block, x, y, z, renderBlocks.overrideBlockTexture);
+            renderNorthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
+            renderSouthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
             tessellator.setColorOpaque_F(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
-            renderEastFace(tessellator, block, x, y, z, renderBlocks.overrideBlockTexture);
-            renderWestFace(tessellator, block, x, y, z, renderBlocks.overrideBlockTexture);
+            renderEastFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
+            renderWestFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
             renderBlocks.overrideBlockTexture = null;
         }
 
@@ -59,37 +63,39 @@ public class BlockModelLeavesCacao<T extends Block> extends BlockModelLeaves<T>
         super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
+        AABB bounds = block.getBounds();
+
         final IconCoordinate cacaoCoord = growthStages[BlockLeavesCacao.MAX_GROWTH_STATE - 1];
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
similarity index 81%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
index cc66d166e..ecfd2f639 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLeavesCherryFlowering;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -26,7 +27,7 @@ public class BlockModelLeavesCherryFlowering<T extends Block> extends BlockModel
             renderBlocks.overrideBlockTexture = floweringCherryOverlay;
         }
 
-        renderStandardBlock(tessellator, block, x, y, z, 1.0f, 1.0f, 1.0f);
+        renderStandardBlock(tessellator, block.getBoundsRaw(), x, y, z, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = null;
 
         return true;
@@ -36,37 +37,39 @@ public class BlockModelLeavesCherryFlowering<T extends Block> extends BlockModel
         super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
+        AABB bounds = block.getBoundsRaw();
+
         IconCoordinate cherryCoord = grownCherryOverlay;
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
